﻿using Rhino;
using Rhino.DocObjects;

namespace AddObject
{
    public class AddObjectWatcher
    {
        public bool IsEnabled { get; private set; }
        public AddObjectWatcherComponent Target;
        private AddObjectWatcher()
        {
            IsEnabled = false;
        }
        private static AddObjectWatcher _myInstance;
        public static AddObjectWatcher Instance => _myInstance ?? (_myInstance = new AddObjectWatcher());
        public void Enable(bool enable)
        {
            if (enable != IsEnabled)
            {
                if (enable)
                    RhinoDoc.AddRhinoObject += RhinoDocOnAddRhinoObject;
                else
                    RhinoDoc.AddRhinoObject -= RhinoDocOnAddRhinoObject;
            }
            IsEnabled = enable;
        }
        private void RhinoDocOnAddRhinoObject(object sender, RhinoObjectEventArgs e)
        {
            Target.Geos.Add(e.TheObject.Geometry);
            Target.ExpireSolution(true);
        }
    }
}
