﻿using System;
using System.Collections.Generic;
using Grasshopper.Kernel;
using Rhino.Geometry;

namespace AddObject
{
    public class AddObjectWatcherComponent : GH_Component
    {
        public List<GeometryBase> Geos = new List<GeometryBase>();
        public AddObjectWatcherComponent()
          : base("AddObjectWatcher", "Nickname",
              "Description",
              "Category", "Subcategory")
        {
        }
        protected override void RegisterInputParams(GH_Component.GH_InputParamManager pManager)
        {
            pManager.AddBooleanParameter("reset", "Reset", "Reset", GH_ParamAccess.item, false);
            pManager.AddBooleanParameter("Watch", "Watch", "Watch", GH_ParamAccess.item, true);
        }
        protected override void RegisterOutputParams(GH_Component.GH_OutputParamManager pManager)
        {
            pManager.AddGeometryParameter("Geometry", "G", "Last added geometry", GH_ParamAccess.list);
        }
        protected override void SolveInstance(IGH_DataAccess DA)
        {
            var reset = false;
            DA.GetData(0, ref reset);
            var watch = true;
            DA.GetData(1, ref watch);
            if(reset)
                Geos = new List<GeometryBase>();
            AddObjectWatcher.Instance.Target = this;
            AddObjectWatcher.Instance.Enable(watch);
            DA.SetDataList(0, Geos);
        }
        protected override System.Drawing.Bitmap Icon => null;
        public override Guid ComponentGuid => new Guid("d2202838-c05e-4f8a-a254-a0a589db149a");
    }
}
